package com.cweb.controller;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alipay.api.AlipayClient;
import com.alipay.api.DefaultAlipayClient;
import com.alipay.api.request.AlipaySystemOauthTokenRequest;
import com.alipay.api.response.AlipaySystemOauthTokenResponse;
import com.hfkj.channel.alipay.utils.AlipayRequest;
import com.hfkj.channel.alipay.utils.AlipayUtils;
import com.hfkj.channel.lakala.LaKaLaLedgerService;
import com.hfkj.channel.lakala.LaKaLaTradeService;
import com.hfkj.channel.lakala.config.LaKaLaConfig;
import com.hfkj.channel.saas.SaasMerService;
import com.hfkj.channel.saas.utils.SaasCommon;
import com.hfkj.channel.saas.saasenum.FileImgType;
import com.hfkj.channel.saas.utils.SaasMerRequest;
import com.hfkj.channel.weixin.WeiXinMerService;
import com.hfkj.channel.weixin.utils.WxUtils;
import com.hfkj.channel.weixin.utils.sdk.WXPayConstants;
import com.hfkj.common.utils.DateUtil;
import com.hfkj.common.utils.HttpsUtils;
import com.hfkj.common.utils.ResponseMsgUtil;
import com.hfkj.config.device.SoundService;
import com.hfkj.config.mqtt.MqttProviderService;
import com.hfkj.entity.BsLklMcc;
import com.hfkj.entity.SecRegion;
import com.hfkj.model.ResponseData;
import com.hfkj.service.BsLklMccService;
import com.hfkj.service.CommonService;
import com.hfkj.service.SecRegionService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.collections4.MapUtils;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.io.File;
import java.math.BigDecimal;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

@Controller
@RequestMapping(value = "/test")
@Api(value = "测试")
public class TestController {

    private static Logger log = LoggerFactory.getLogger(TestController.class);

    @Resource
    private WeiXinMerService weiXinMerService;

    @Resource
    private MqttProviderService mqttProviderService;

    @Resource
    private SoundService soundService;

    @Resource
    private SaasCommon saasCommon;

    @Resource
    private SaasMerRequest saasMerRequest;

    @Resource
    private SaasMerService saasMerService;

    @Resource
    private LaKaLaTradeService laKaLaTradeService;

    @Resource
    private CommonService commonService;

    @Resource
    private BsLklMccService lklMccService;
    @Resource
    private LaKaLaLedgerService laKaLaLedgerService;

    @RequestMapping(value="/rotationQueryTrade",method = RequestMethod.GET)
    @ResponseBody
    @ApiOperation(value = "交易【被扫】")
    public ResponseData rotationQueryTrade() {
        try {

            // return ResponseMsgUtil.success(LaKaLaConfig.queryCardBin("3100020709200056842"));
            return ResponseMsgUtil.success(laKaLaTradeService.preorder(""));

        } catch (Exception e) {
            log.error(e.getMessage(), e);
            return ResponseMsgUtil.exception(e);
        }
    }

    @RequestMapping(value="/saasGetToken",method = RequestMethod.GET)
    @ResponseBody
    @ApiOperation(value = "saasGetToken")
    public ResponseData saasGetToken() {
        try {

            // return ResponseMsgUtil.success(LaKaLaConfig.queryCardBin("3100020709200056842"));
            return ResponseMsgUtil.success(saasCommon.getToken());

        } catch (Exception e) {
            log.error(e.getMessage(), e);
            return ResponseMsgUtil.exception(e);
        }
    }

    @RequestMapping(value="/saasTest",method = RequestMethod.GET)
    @ResponseBody
    @ApiOperation(value = "saasTest")
    public ResponseData saasTest(@RequestParam(value = "code", required = true) String code) {
        try {
            // return ResponseMsgUtil.success(saasCommon.fileUpload(new File("D:/home/project/gratia-pay/filesystem/share/1680164428924.png"), "OTHERS", "0"));
            // 996900  6900 6905
            // return ResponseMsgUtil.success(saasCommon.getArea("1"));
            // return ResponseMsgUtil.success(saasCommon.getBank("6530", "大坪支行"));

            return ResponseMsgUtil.success(laKaLaLedgerService);
            // return ResponseMsgUtil.success("");
            // 1200
            // return ResponseMsgUtil.success(saasCommon.fileUpload(new HashMap<>()));
           /* AlipaySystemOauthTokenRequest request = new AlipaySystemOauthTokenRequest();
            request.setGrantType("authorization_code");
            request.setCode(code);
            AlipaySystemOauthTokenResponse response = AlipayUtils.initClient().certificateExecute(request);
            if(response.isSuccess()){
                System.out.println("调用成功");
                return ResponseMsgUtil.success(response);
            } else {
                System.out.println("调用失败");
                return ResponseMsgUtil.success("调用失败");
            }*/
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            return ResponseMsgUtil.exception(e);
        }
    }

    public static String test(String str, Integer type) {
        char[] chars = str.toCharArray();
// oP: '省' 的偏移, oC: '市' 的偏移, oR: "自治区" 的偏移
        int oP = -1, oC = -1, oR = -1;
        char ch;
        for (int i = 0; i < chars.length; i++) {
            ch = chars[i];
            // 一般来说 '省' 的位置会比 '市' 早出现
            if (ch == '省') {
                oP = i;
            } else if (ch == '市') {
                oC = i;
                // 找到 '市' 后就可以跳出循环了
                break;
            } else if (ch == '自'
                    && i + 2 < chars.length
                    && chars[i + 1] == '治'
                    && chars[i + 2] == '区') {
                // "自治区" 出现的几率挺小
                oR = i + 2;
            }
        }

        if (type == 1) {
            if (oC != -1) {
                str = str.substring(oC + 1);
            } else if (oP != -1) {
                str = str.substring(oP + 1);
            } else if (oR != -1) {
                str = str.substring(oR + 1);
            }
        } else if (type == 2) {
            if (oP != -1) {
                str = str.substring(oP + 1);
            } else if (oR != -1) {
                str = str.substring(oR + 1);
            }
        }

        return str;
    }
    @RequestMapping(value="/soundSendMsg",method = RequestMethod.GET)
    @ResponseBody
    @ApiOperation(value = "音响发送消息")
    public ResponseData soundSendMsg() {
        try {

/*            AlipayClient alipayClient = AlipayUtils.initClient();

            AntMerchantExpandIndirectZftConsultRequest request = new AntMerchantExpandIndirectZftConsultRequest();
            request.setBizContent("");
            AntMerchantExpandIndirectZftConsultResponse execute = alipayClient.certificateExecute(request);*/


            // soundService.sendPayMsg("898604A2192181729951", new BigDecimal("12.99"));
            soundService.geSoundInfo("898604A2192181729951");
            return ResponseMsgUtil.success("");
            // soundService.geSoundDetail("898604A2192181729951");
            // return ResponseMsgUtil.success(AlipayRequest.imageUpload("C:/Users/hurui/Desktop/default_oil_station.jpg"));

        } catch (Exception e) {
            log.error(e.getMessage(), e);
            return ResponseMsgUtil.exception(e);
        }
    }

    @RequestMapping(value="/merchantIndirectConsult",method = RequestMethod.GET)
    @ResponseBody
    @ApiOperation(value = "图片上传")
    public ResponseData merchantIndirectConsult() {
        try {

            Map<String,Object> body = new HashMap<>();
            body.put("external_id", System.currentTimeMillis());
            body.put("name", "");
            body.put("alias_name", "");
            body.put("merchant_type", "");
            body.put("mcc", "");
            body.put("cert_no", "");
            body.put("cert_type", "");
            body.put("cert_image", "");
            body.put("cert_name", "");
            body.put("cert_image_back", "");
            body.put("legal_name", "");
            body.put("legal_cert_no", "");
            body.put("legal_cert_front_image", "");
            body.put("legal_cert_back_image", "");
            body.put("service_phone", "");

            Map<String,Object> businessAddress = new HashMap<>();
            businessAddress.put("city_code", "");
            businessAddress.put("district_code", "");
            businessAddress.put("address", "");
            businessAddress.put("province_code", "");
            body.put("business_address", businessAddress);


            Map<String,Object> contactInfos = new HashMap<>();
            contactInfos.put("name", "");
            contactInfos.put("phone", "");
            contactInfos.put("mobile", "");
            contactInfos.put("email", "");
            contactInfos.put("id_card_no", "");
            body.put("contact_infos", contactInfos);

            Map<String,Object> bizCards = new HashMap<>();
            bizCards.put("account_holder_name", "");
            bizCards.put("account_no", "");
            bizCards.put("account_inst_province", "");
            bizCards.put("account_inst_city", "");
            bizCards.put("account_branch_name", "");
            bizCards.put("usage_type", "");
            bizCards.put("account_type", "");
            bizCards.put("account_inst_name", "");
            bizCards.put("account_inst_id", "");
            bizCards.put("bank_code", "");
            body.put("biz_cards", bizCards);

            Map<String,Object> qualifications = new HashMap<>();
            qualifications.put("industry_qualification_type", "");
            qualifications.put("industry_qualification_image", "");
            body.put("qualifications", qualifications);

            body.put("out_door_images", "");
            // body.put("service", ['当面付', 'app支付', 'wap支付', '电脑支付']);
            body.put("sign_time_with_isv", DateUtil.date2String(new Date(), "yyyy-MM-dd"));

            Map<String,Object> sites = new HashMap<>();
            body.put("sites", sites);

            Map<String,Object> invoiceInfo = new HashMap<>();
            body.put("invoice_info", invoiceInfo);


            AlipayRequest.merchantIndirectConsult(JSONObject.toJSONString(body));

            return ResponseMsgUtil.success("");

        } catch (Exception e) {
            log.error(e.getMessage(), e);
            return ResponseMsgUtil.exception(e);
        }
    }

    @RequestMapping(value="/imageUpload",method = RequestMethod.GET)
    @ResponseBody
    @ApiOperation(value = "图片上传")
    public ResponseData imageUpload() {
        try {

            return ResponseMsgUtil.success(AlipayRequest.imageUpload("C:/Users/hurui/Desktop/default_oil_station.jpg"));

        } catch (Exception e) {
            log.error(e.getMessage(), e);
            return ResponseMsgUtil.exception(e);
        }
    }

    @RequestMapping(value = "/rebate", method = RequestMethod.GET)
    @ResponseBody
    @ApiOperation(value = "返利")
    public ResponseData rebate(@RequestParam(name = "orderNo", required = true) String orderNo,
                                            @RequestParam(name = "orderId", required = true) Long orderId,
                                            @RequestParam(name = "price", required = true) BigDecimal price) {
        try {

            Map<String , Object> mapPost = new HashMap<>();
            mapPost.put("apiKey" , "0C7897EA3BD96156A5881618FF2FF645");
            mapPost.put("merchId" , "20230258302");
            mapPost.put("productType" , 102);
            mapPost.put("orderNo" , orderNo);
            mapPost.put("userId" , 366);
            mapPost.put("orderId" , orderId);
            mapPost.put("price" , price);
            mapPost.put("title" , "南充大饭店");
            mapPost.put("createTime" , new Date());


            mapPost.put("sign" , WxUtils.generateSignApi(mapPost, MapUtils.getString(mapPost, "apiKey"), WXPayConstants.SignType.MD5));
            return ResponseMsgUtil.success(HttpsUtils.doPost("http://localhost:9902/v1/orderRebate/rebate" , mapPost , new HashMap<>()));
        } catch (Exception e) {
            log.error("HighOrderController --> getBackendToken() error!", e);
            return ResponseMsgUtil.exception(e);
        }
    }

}
