package com.api.config.controller;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.hfkj.channel.lakala.config.LaKaLaConfig;
import com.hfkj.channel.saas.utils.SaasCommon;
import com.hfkj.common.exception.ErrorCode;
import com.hfkj.common.exception.ErrorHelp;
import com.hfkj.common.exception.SysCode;
import com.hfkj.common.utils.ResponseMsgUtil;
import com.hfkj.entity.BsCompany;
import com.hfkj.entity.SecRegion;
import com.hfkj.model.ResponseData;
import com.hfkj.model.StoreModel;
import com.hfkj.service.BsCompanyService;
import com.hfkj.service.BsIndustryService;
import com.hfkj.service.BsLklMccService;
import com.hfkj.service.CommonService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


@RestController
@RequestMapping(value="/common")
@Api(value="共用接口")
public class CommonController {

	Logger log = LoggerFactory.getLogger(CommonController.class);

	@Resource
	private BsIndustryService industryService;


	@RequestMapping(value="/getIndustry",method = RequestMethod.GET)
	@ResponseBody
	@ApiOperation(value = "获取行业数据")
	public ResponseData getIndustry() {
		try {

			return ResponseMsgUtil.success(industryService.getCacheIndustry());

		} catch (Exception e) {
			log.error("CommonController --> getIndustry() error!", e);
			return ResponseMsgUtil.exception(e);
		}
	}



}
