package com.hfkj.service;

import com.hfkj.entity.BsTradeOrder;
import com.hfkj.entity.BsTradeOrderProfitSharing;

import java.util.List;

/**
 * 交易订单分账记录
 * @className: BsTradeOrderProfitSharingService
 * @author: HuRui
 * @date: 2023/2/22
 **/
public interface BsTradeOrderProfitSharingService {

    /**
     * 编辑数据
     * @param profitSharing
     */
    void editData(BsTradeOrderProfitSharing profitSharing);

    /**
     * 创建分账
     * @param tradeOrder
     */
    void createProfitSharing(BsTradeOrder tradeOrder);

    /**
     * 根据分账单号 查询详情
     * @param profitSharingOrderNo
     * @return
     */
    BsTradeOrderProfitSharing getDetailByProfitSharingOrderNo(String profitSharingOrderNo);

    /**
     * 获取需要分账的订单
     * @return
     */
    List<BsTradeOrderProfitSharing> getNeedProfitSharingOrder();

    /**
     * 获取需要完结的订单
     * @return
     */
    List<BsTradeOrderProfitSharing> getNeedFinishProfitSharingOrder();
}
