package com.hfkj.service.impl;

import com.hfkj.channel.lakala.LaKaLaLedgerService;
import com.hfkj.dao.BsMerLedgerMapper;
import com.hfkj.entity.BsMerLedger;
import com.hfkj.entity.BsMerLedgerExample;
import com.hfkj.service.BsMerLedgerService;
import com.hfkj.sysenum.PlatformTypeEnum;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;

/**
 * @className: BsMerLedgerServiceImpl
 * @author: HuRui
 * @date: 2023/4/18
 **/
@Service("merLedgerService")
public class BsMerLedgerServiceImpl implements BsMerLedgerService {

    @Resource
    private BsMerLedgerMapper merLedgerMapper;

    @Resource
    private LaKaLaLedgerService laKaLaLedgerService;

    @Override
    public void editMerLedger(BsMerLedger merLedger) {
        if (merLedger.getId() == null) {
            merLedger.setCreateTime(new Date());
            merLedger.setUpdateTime(new Date());
            merLedgerMapper.insert(merLedger);
        } else {
            merLedger.setUpdateTime(new Date());
            merLedgerMapper.updateByPrimaryKey(merLedger);
        }
    }

    @Override
    public void merLedgerApply(BsMerLedger merLedger) {
        editMerLedger(merLedger);

        if (merLedger.getPlatformType().equals(PlatformTypeEnum.type1.getNumber())) {
            laKaLaLedgerService.applyLedger(merLedger.getId());
        }
    }

    @Override
    public BsMerLedger getMerLedger(Long merId, PlatformTypeEnum platformType) {
        BsMerLedgerExample example = new BsMerLedgerExample();
        example.createCriteria()
                .andMerIdEqualTo(merId)
                .andStatusNotEqualTo(0)
                .andPlatformTypeEqualTo(platformType.getNumber());
        List<BsMerLedger> list = merLedgerMapper.selectByExample(example);
        if (list.size() > 0) {
            return list.get(0);
        }
        return null;
    }

    @Override
    public BsMerLedger getMerLedgerById(Long id) {
        return merLedgerMapper.selectByPrimaryKey(id);
    }
}
